package tools;

import cartago.*;
import fr.uga.pddl4j.encoding.CodedProblem;
import fr.uga.pddl4j.parser.Parser;
import fr.uga.pddl4j.parser.Problem;
import fr.uga.pddl4j.parser.Symbol;
import fr.uga.pddl4j.planners.Planner.Name;
import fr.uga.pddl4j.planners.ProblemFactory;
import fr.uga.pddl4j.planners.statespace.AbstractStateSpacePlanner;
import fr.uga.pddl4j.planners.statespace.StateSpacePlannerFactory;
import fr.uga.pddl4j.util.Plan;
import org.apache.logging.log4j.core.util.FileUtils;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.*;

import static java.nio.file.Files.readString;

public class Planner extends Artifact{
    
    final StateSpacePlannerFactory stateSpacePlannerFactory = StateSpacePlannerFactory.getInstance();
    final Name plannerName = AbstractStateSpacePlanner.DEFAULT_PLANNER;
    final AbstractStateSpacePlanner planner = stateSpacePlannerFactory.getPlanner(plannerName);

    /*
    The operation buildPlan will take the pddl files and generate a string plan as an output thanks to OpFeedbackParam
     */
    @OPERATION
    public void buildPlan(String domainfile, String probName, Object[] objects, Object[] initStates, Object[] goalStates, OpFeedbackParam<Object> exePlans)
            throws IOException, InterruptedException, UnknownArtifactException, OperationException, IOException {

        // PDDL files to be triggerd domain and problem
        String domain = Files.readString(Path.of("src\\\\agt\\\\pddl\\\\"+domainfile));

        String[] objectArray = Arrays.asList(objects).toArray(new String[0]);
        List<String> listOfObjects = Arrays.asList(objectArray);

        String[] initStatesArray = Arrays.asList(initStates).toArray(new String[0]);
        List<String> listOfInitState = Arrays.asList(initStatesArray);

        String[] goalStatesArray = Arrays.asList(goalStates).toArray(new String[0]);
        List<String> listOfGoalState = Arrays.asList(goalStatesArray);

        Parser parser = new Parser();
        parser.parseFromString(domain);
        String domainName = parser.getDomain().getName().toString();


        try {
            StringBuilder problemDefine = new StringBuilder();
            String beginFile = "(define (problem  " + probName;
            problemDefine.append(beginFile + ") \n");
            problemDefine.append("\t (:domain  " + domainName + ") \n");

            // adding the objects of the problem for now we just have the artifacts list
            problemDefine.append("\t (:objects \n\t\t");
            for (String obj : listOfObjects) {
                problemDefine.append(obj + "\n\t\t");
            }
            problemDefine.append("\n\t)\n");

            //adding the init elements which have predicates
            problemDefine.append("\t (:init \n\t\t");
            for (String init : listOfInitState) {
                problemDefine.append("(" + init + ")\n\t\t");
            }
            problemDefine.append("\n\t)\n");

            //adding the goal state that need to be achieved
            problemDefine.append("\t (:goal \t (and \n\t\t");
            for (String goalState : listOfGoalState) {
                problemDefine.append("(" + goalState + ")" + "\n\t\t");
            }
            problemDefine.append(") \n \t ) \n )");
            // Having a file gives possibillity of having historical file to reuse with other planner.
            String initProblem = String.valueOf(problemDefine);


            // Creates the problem factory
            final ProblemFactory factory = ProblemFactory.getInstance();
            if (!initProblem.isEmpty()) {
                factory.parseFromString(domain, initProblem);
                final CodedProblem pb = factory.encode();
                final Plan plan = planner.search(pb);

                // Create a String variable to set a plan which generated by the planner.
                StringBuilder sb = new StringBuilder();
                String initPlan = "+!" + probName + " : true <- ";

                sb.append(initPlan);

                List<String> constants = pb.getConstants();
                List<String> listOfMatchedArt = new ArrayList<String>();

                for (int i = 0; i < plan.size(); i++) {
                    String action = plan.actions().get(i).getName();
                    int numOfParam = plan.actions().get(i).getArity();
                    sb.append(action + "( ");

                    for (int j = 0; j < numOfParam; j++) {
                        int keyOfParam = plan.actions().get(i).getValueOfParameter(j);
                        String param = constants.get(keyOfParam);

                        sb.append(" " + param + " ");
                        StringBuilder comma = j == numOfParam - 1 ? sb.append(" ") : sb.append(",");

                        try {
                            if (!lookupArtifact(param).toString().isEmpty()) {
                                listOfMatchedArt.add(param);
                            }
                        } catch (OperationException e) {
                            // This exception is empty because it cause an error which will stop the loop
                            // but it means also that the param will not be considered as an artifact name.
                            // also it means will not match the existing artifact when we pass param in lookupArtifact(param)
                        }
                    }
                    if (i == plan.size() - 1) {
                        if (listOfMatchedArt.size() == 1) {
                            sb.append(")[artifact_name(\"" + listOfMatchedArt.get(0) + "\")]\n");
                        } else {
                            sb.append(")\n");
                        }
                    } else {
                        if (listOfMatchedArt.size() == 1) {
                            sb.append(")[artifact_name(\"" + listOfMatchedArt.get(0) + "\")];\n");
                        } else {
                            sb.append(");\n");
                        }
                    }
                    listOfMatchedArt.clear();
                }
                sb.append(".");
                String res = sb.toString();
                exePlans.set(res);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
}
